%define debug_package %{nil}
Summary: Quantum Linear Tape File System
Name: qtmltfs
Version: 2.2.2
Release: 2%{?dist}
Group: Util
Vendor: Quantum
License: GNU Lesser GPL Version 2.1
Source: %{name}-%{version}-2.tar.gz
Requires:  fuse >= 2.7
Requires:  libxml2
Requires:  libicu
Requires: libuuid
BuildRoot: /tmp/rpm/%{name}-%{version}
BuildRequires: icu
BuildRequires: libicu-devel
BuildRequires: fuse-devel
BuildRequires: libuuid-devel
BuildRequires: libxml2-devel
BuildRequires:	autoconf m4

%define         _prefix  /opt/QUANTUM/ltfs
%define         _sysconf /etc
%define         _ulocal  /usr/local

%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define is_redhat %(test -e /etc/redhat-release && echo 1 || echo 0)

%if %is_redhat
Requires: fuse-libs >= 2.7
Requires: libicu
Requires: libxml2
%define _mandir /usr/local/share/man
%define qtm_docdir %{_docdir}/%{name}-%{version}
%else
%if %is_suse
Requires: libfuse2 >= 2.7
Requires: libicu
Requires: libxml2
%define _mandir /usr/local/man
%define qtm_docdir %{_docdir}/%{name}
%else
Requires: fuse >= 2.7
Requires: libicu
Requires: libxml2
%define _mandir /usr/local/share/man
%define qtm_docdir %{_docdir}/%{name}-%{version}
%endif
%endif

%description
Quantum Linear Tape File System (QTM LTFS) enables standard file operations on LTO-5 and LTO-6 tape media

%prep
%setup -q -n qtmltfs

%build
rm -rf $RPM_BUILD_ROOT
export PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/lib64/pkgconfig
./configure --prefix=%{_prefix} --libdir=%{_libdir} --sysconfdir=%{_sysconf} --mandir=%{_mandir}
make 

## %pretrans
## if [ -d /usr/local/lib/ltfs ]
## then
##     mv /usr/local/lib/ltfs /usr/local/lib/ltfs.rpmsave
##     ln -s /usr/local/lib/ltfs.rpmsave /usr/local/lib/ltfs
## fi
## 
## if [ -d /usr/local/lib64/ltfs ]
## then
##     mv /usr/local/lib64/ltfs /usr/local/lib64/ltfs.rpmsave
##     ln -s /usr/local/lib64/ltfs.rpmsave /usr/local/lib64/ltfs
## fi
## 
## %posttrans
## if [ -s /usr/local/lib/ltfs.rpmnew ]
## then
##     rm -rf /usr/local/lib/ltfs
##     mv /usr/local/lib/ltfs.rpmnew /usr/local/lib/ltfs
##     /sbin/ldconfig
## fi
## 
## if [ -s /usr/local/lib64/ltfs.rpmnew ]
## then
##     rm -rf /usr/local/lib64/ltfs
##     mv /usr/local/lib64/ltfs.rpmnew /usr/local/lib64/ltfs
##     /sbin/ldconfig
## fi

%pretrans -p <lua>
require 'posix'
require 'os'
if (posix.stat("/usr/local/lib/ltfs", "type") == "directory") then
  os.rename("/usr/local/lib/ltfs", "/usr/local/lib/ltfs.rpmsave")
  posix.link("/usr/local/lib/ltfs.rpmsave", "/usr/local/lib/ltfs")
end
if (posix.stat("/usr/local/lib64/ltfs", "type") == "directory") then
  os.rename("/usr/local/lib64/ltfs", "/usr/local/lib64/ltfs.rpmsave")
  posix.link("/usr/local/lib64/ltfs.rpmsave", "/usr/local/lib64/ltfs")
end

%posttrans -p <lua>
require 'posix'
require 'os'
if (posix.stat("/usr/local/lib/ltfs", "type") == "symlink") then
  os.execute("rm -rf /usr/local/lib/ltfs")
  os.rename("/usr/local/lib/ltfs.rpmnew", "/usr/local/lib/ltfs")
  os.execute("/sbin/ldconfig")
end

%pre
if cat /proc/mounts | awk {'print $1'} | grep -q "^ltfs$"
then
    echo
    echo "Error: please unmount all LTFS instances before installing this RPM."
    echo
    exit 1
fi

%preun
if cat /proc/mounts | awk {'print $1'} | grep -q "^ltfs$"
then
    echo
    echo "Error: please unmount all LTFS instances before uninstalling this RPM."
    echo
    exit 1
fi
/sbin/service ltfs stop
/sbin/chkconfig --del ltfs

%install
[ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
make -e prefix=$RPM_BUILD_ROOT%{_prefix} libdir=$RPM_BUILD_ROOT%{_libdir} includedir=$RPM_BUILD_ROOT%{_includedir} sysconfdir=$RPM_BUILD_ROOT%{_sysconf} mandir=$RPM_BUILD_ROOT%{_mandir} install
mkdir $RPM_BUILD_ROOT%{_libdir}/ltfs
mv $RPM_BUILD_ROOT%{_libdir}/libdriver-* $RPM_BUILD_ROOT%{_libdir}/ltfs
mv $RPM_BUILD_ROOT%{_libdir}/libiosched-* $RPM_BUILD_ROOT%{_libdir}/ltfs
mv $RPM_BUILD_ROOT%{_libdir}/libkmi-* $RPM_BUILD_ROOT%{_libdir}/ltfs
mkdir -p $RPM_BUILD_ROOT/etc/init.d
cp $RPM_BUILD_ROOT%{_datadir}/ltfs/ltfs $RPM_BUILD_ROOT/etc/init.d
mv $RPM_BUILD_ROOT%{_bindir}/ltfs $RPM_BUILD_ROOT%{_bindir}/ltfs-singledrive
mkdir -p $RPM_BUILD_ROOT%{qtm_docdir}

# create symbolic links (Commands)
[ ! -d $RPM_BUILD_ROOT%{_ulocal}/bin ] && mkdir -p $RPM_BUILD_ROOT%{_ulocal}/bin
ln -s -f %{_bindir}/ltfs-singledrive $RPM_BUILD_ROOT%{_ulocal}/bin/ltfs
ln -s -f %{_bindir}/mkltfs $RPM_BUILD_ROOT%{_ulocal}/bin/mkltfs
ln -s -f %{_bindir}/ltfsck $RPM_BUILD_ROOT%{_ulocal}/bin/ltfsck
ln -s -f %{_bindir}/unltfs $RPM_BUILD_ROOT%{_ulocal}/bin/unltfs

# create symbolic links (Libraries)
[ ! -d $RPM_BUILD_ROOT%{_ulocal}/%{_lib} ] && mkdir -p $RPM_BUILD_ROOT%{_ulocal}/%{_lib}
for FN in $RPM_BUILD_ROOT%{_libdir}/*
do
    b=`basename ${FN}`
    [ -f ${FN} ] && ln -s -f %{_libdir}/${b} $RPM_BUILD_ROOT%{_ulocal}/%{_lib}/${b}
done

# create symbolic links (Backends)
ln -s -f  %{_libdir}/ltfs $RPM_BUILD_ROOT%{_ulocal}/%{_lib}/ltfs

# create symbolic links (Doc)
[ ! -d $RPM_BUILD_ROOT%{_ulocal}/share/doc ] && mkdir -p $RPM_BUILD_ROOT%{_ulocal}/share/doc
ln -s -f %{qtm_docdir} $RPM_BUILD_ROOT%{_ulocal}/share/doc/%{name}-%{version}

# Fix everything to put it in the standard system place
#cd $RPM_BUILD_ROOT
#mv usr/local/bin usr/bin
#mv opt/QUANTUM/ltfs/bin/* usr/bin
#rmdir opt/QUANTUM/ltfs/bin
#mkdir usr/include
#mv opt/QUANTUM/ltfs/include/ltfs usr/include
#mv opt/QUANTUM/ltfs/lib* usr
#mv opt/QUANTUM/ltfs/share usr/share
#mv usr/local/share/man usr/share
#mv usr/local/share/doc/* usr/share/doc
#mv usr/local/lib*/* usr/lib*
#mv opt/QUANTUM/ltfs/share/doc/qtmltfs usr/share/doc

%post
/sbin/ldconfig
/sbin/chkconfig --add ltfs
/sbin/service ltfs start

if [ -d /usr/local/lib/ltfs.rpmsave ]
then
    mv /usr/local/lib/ltfs /usr/local/lib/ltfs.rpmnew
    mv /usr/local/lib/ltfs.rpmsave /usr/local/lib/ltfs
fi

if [ -d /usr/local/lib64/ltfs.rpmsave ]
then
    mv /usr/local/lib64/ltfs /usr/local/lib64/ltfs.rpmnew
    mv /usr/local/lib64/ltfs.rpmsave /usr/local/lib64/ltfs
fi

%postun
/sbin/ldconfig

%clean
[ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/*
%{_includedir}/*
%{_datadir}/*
%config /etc/ltfs.conf
%config /etc/ltfs.conf.local
/etc/init.d/ltfs
/usr/local/*
%doc doc/README.txt doc/INSTALLING.linux doc/COPYING.LIB doc/NOTICES.txt doc/ltfs.conf.example doc/ltfs.conf.local.example
